// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1alpha1 "github.com/openshift/aws-ebs-csi-driver-operator/pkg/apis/operator/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeAWSEBSDrivers implements AWSEBSDriverInterface
type FakeAWSEBSDrivers struct {
	Fake *FakeCsiV1alpha1
}

var awsebsdriversResource = schema.GroupVersionResource{Group: "csi.openshift.io", Version: "v1alpha1", Resource: "awsebsdrivers"}

var awsebsdriversKind = schema.GroupVersionKind{Group: "csi.openshift.io", Version: "v1alpha1", Kind: "AWSEBSDriver"}

// Get takes name of the aWSEBSDriver, and returns the corresponding aWSEBSDriver object, and an error if there is any.
func (c *FakeAWSEBSDrivers) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.AWSEBSDriver, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(awsebsdriversResource, name), &v1alpha1.AWSEBSDriver{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.AWSEBSDriver), err
}

// List takes label and field selectors, and returns the list of AWSEBSDrivers that match those selectors.
func (c *FakeAWSEBSDrivers) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.AWSEBSDriverList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(awsebsdriversResource, awsebsdriversKind, opts), &v1alpha1.AWSEBSDriverList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.AWSEBSDriverList{ListMeta: obj.(*v1alpha1.AWSEBSDriverList).ListMeta}
	for _, item := range obj.(*v1alpha1.AWSEBSDriverList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested aWSEBSDrivers.
func (c *FakeAWSEBSDrivers) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(awsebsdriversResource, opts))
}

// Create takes the representation of a aWSEBSDriver and creates it.  Returns the server's representation of the aWSEBSDriver, and an error, if there is any.
func (c *FakeAWSEBSDrivers) Create(ctx context.Context, aWSEBSDriver *v1alpha1.AWSEBSDriver, opts v1.CreateOptions) (result *v1alpha1.AWSEBSDriver, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(awsebsdriversResource, aWSEBSDriver), &v1alpha1.AWSEBSDriver{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.AWSEBSDriver), err
}

// Update takes the representation of a aWSEBSDriver and updates it. Returns the server's representation of the aWSEBSDriver, and an error, if there is any.
func (c *FakeAWSEBSDrivers) Update(ctx context.Context, aWSEBSDriver *v1alpha1.AWSEBSDriver, opts v1.UpdateOptions) (result *v1alpha1.AWSEBSDriver, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(awsebsdriversResource, aWSEBSDriver), &v1alpha1.AWSEBSDriver{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.AWSEBSDriver), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeAWSEBSDrivers) UpdateStatus(ctx context.Context, aWSEBSDriver *v1alpha1.AWSEBSDriver, opts v1.UpdateOptions) (*v1alpha1.AWSEBSDriver, error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateSubresourceAction(awsebsdriversResource, "status", aWSEBSDriver), &v1alpha1.AWSEBSDriver{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.AWSEBSDriver), err
}

// Delete takes name of the aWSEBSDriver and deletes it. Returns an error if one occurs.
func (c *FakeAWSEBSDrivers) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteAction(awsebsdriversResource, name), &v1alpha1.AWSEBSDriver{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeAWSEBSDrivers) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewRootDeleteCollectionAction(awsebsdriversResource, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha1.AWSEBSDriverList{})
	return err
}

// Patch applies the patch and returns the patched aWSEBSDriver.
func (c *FakeAWSEBSDrivers) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.AWSEBSDriver, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(awsebsdriversResource, name, pt, data, subresources...), &v1alpha1.AWSEBSDriver{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.AWSEBSDriver), err
}
